#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Mar 16 15:48:47 2021

@author: moreaul
"""
import numpy as np
from random import random

def candidate(X,delta_X,min_X,max_X): 
    cand = np.zeros(X.shape[0])   
    
    for k in range(X.shape[0]):
        # force jump to remain within domain bounds
        if X[k] + delta_X[k] >= max_X[k]:
            bound_max = max_X[k]            
        else:
            bound_max = X[k] + delta_X[k]
                           
        if X[(k)] - delta_X[(k)] <= min_X[k]:
            bound_min = min_X[k]
        else:
            bound_min = X[k] - delta_X[k]
        # random candidate generation in multispace delat_X box around position  
        cand[k] = bound_min + (bound_max-bound_min)*random()

    return cand    